diff a/test/jdk/jdk/incubator/vector/templates/Perf-Compare.template b/test/jdk/jdk/incubator/vector/templates/Perf-Compare.template
--- /dev/null
+++ b/test/jdk/jdk/incubator/vector/templates/Perf-Compare.template
@@ -0,0 +1,19 @@
+    @Benchmark
+    public Object [[TEST]][[TEST_TYPE]][[OP_NAME]]() {
+        $type$[] a = fa.apply(size);
+        $type$[] b = fb.apply(size);
+        boolean[] ms = fmt.apply(size);
+        VectorMask<$Wideboxtype$> m = VectorMask.fromArray(SPECIES, ms, 0);
+
+        for (int ic = 0; ic < INVOC_COUNT; ic++) {
+            for (int i = 0; i < a.length; i += SPECIES.length()) {
+                $abstractvectortype$ av = $abstractvectortype$.fromArray(SPECIES, a, i);
+                $abstractvectortype$ bv = $abstractvectortype$.fromArray(SPECIES, b, i);
+
+                // accumulate results, so JIT can't eliminate relevant computations
+                m = m.and(av.compare(VectorOperators.[[TEST]], bv));
+            }
+        }
+
+        return m;
+    }
